/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-03-04 09:10:54,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.security.configuration.model;

/**
 * The security configuration.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class SecurityConfiguration
    implements org.sonatype.configuration.Configuration, java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The version of the model.
     */
    private String version;

    /**
     * The only mandatory element. If true, the application
     * instance will be secured.
     */
    private boolean enabled = false;

    /**
     * 
     *             If enabled, the users will be able to access DAV
     * resources unauthenticated, if Realm allows. To
     *             set rights for unauthenticated users, use
     * "anonymous" username.
     */
    private boolean anonymousAccessEnabled = false;

    /**
     * 
     *             The username used to log in as anonymous user.
     * The account should be enabled and existing according to
     *             the used JSecurity realm!
     */
    private String anonymousUsername;

    /**
     * 
     *             The username used to log in as anonymous user.
     * The account should be enabled and existing according to
     *             the used JSecurity realm!
     */
    private String anonymousPassword;

    /**
     * Field realms.
     */
    private java.util.List<String> realms;

    /**
     * The id of a security manager to be used by default security
     * system.
     */
    private String securityManager;

    /**
     * Field modelEncoding.
     */
    private String modelEncoding = "UTF-8";


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addRealm.
     * 
     * @param string
     */
    public void addRealm( String string )
    {
        getRealms().add( string );
    } //-- void addRealm( String )

    /**
     * Get the username used to log in as anonymous user. The
     * account should be enabled and existing according to
     *             the used JSecurity realm!
     * 
     * @return String
     */
    public String getAnonymousPassword()
    {
        return this.anonymousPassword;
    } //-- String getAnonymousPassword()

    /**
     * Get the username used to log in as anonymous user. The
     * account should be enabled and existing according to
     *             the used JSecurity realm!
     * 
     * @return String
     */
    public String getAnonymousUsername()
    {
        return this.anonymousUsername;
    } //-- String getAnonymousUsername()

    /**
     * Get the modelEncoding field.
     * 
     * @return String
     */
    public String getModelEncoding()
    {
        return this.modelEncoding;
    } //-- String getModelEncoding()

    /**
     * Method getRealms.
     * 
     * @return List
     */
    public java.util.List<String> getRealms()
    {
        if ( this.realms == null )
        {
            this.realms = new java.util.ArrayList<String>();
        }

        return this.realms;
    } //-- java.util.List<String> getRealms()

    /**
     * Get the id of a security manager to be used by default
     * security system.
     * 
     * @return String
     */
    public String getSecurityManager()
    {
        return this.securityManager;
    } //-- String getSecurityManager()

    /**
     * Get the version of the model.
     * 
     * @return String
     */
    public String getVersion()
    {
        return this.version;
    } //-- String getVersion()

    /**
     * Get if enabled, the users will be able to access DAV
     * resources unauthenticated, if Realm allows. To
     *             set rights for unauthenticated users, use
     * "anonymous" username.
     * 
     * @return boolean
     */
    public boolean isAnonymousAccessEnabled()
    {
        return this.anonymousAccessEnabled;
    } //-- boolean isAnonymousAccessEnabled()

    /**
     * Get the only mandatory element. If true, the application
     * instance will be secured.
     * 
     * @return boolean
     */
    public boolean isEnabled()
    {
        return this.enabled;
    } //-- boolean isEnabled()

    /**
     * Method removeRealm.
     * 
     * @param string
     */
    public void removeRealm( String string )
    {
        getRealms().remove( string );
    } //-- void removeRealm( String )

    /**
     * Set if enabled, the users will be able to access DAV
     * resources unauthenticated, if Realm allows. To
     *             set rights for unauthenticated users, use
     * "anonymous" username.
     * 
     * @param anonymousAccessEnabled
     */
    public void setAnonymousAccessEnabled( boolean anonymousAccessEnabled )
    {
        this.anonymousAccessEnabled = anonymousAccessEnabled;
    } //-- void setAnonymousAccessEnabled( boolean )

    /**
     * Set the username used to log in as anonymous user. The
     * account should be enabled and existing according to
     *             the used JSecurity realm!
     * 
     * @param anonymousPassword
     */
    public void setAnonymousPassword( String anonymousPassword )
    {
        this.anonymousPassword = anonymousPassword;
    } //-- void setAnonymousPassword( String )

    /**
     * Set the username used to log in as anonymous user. The
     * account should be enabled and existing according to
     *             the used JSecurity realm!
     * 
     * @param anonymousUsername
     */
    public void setAnonymousUsername( String anonymousUsername )
    {
        this.anonymousUsername = anonymousUsername;
    } //-- void setAnonymousUsername( String )

    /**
     * Set the only mandatory element. If true, the application
     * instance will be secured.
     * 
     * @param enabled
     */
    public void setEnabled( boolean enabled )
    {
        this.enabled = enabled;
    } //-- void setEnabled( boolean )

    /**
     * Set the modelEncoding field.
     * 
     * @param modelEncoding
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    } //-- void setModelEncoding( String )

    /**
     * Set the list of JSecurity realms used in the application.
     * 
     * @param realms
     */
    public void setRealms( java.util.List<String> realms )
    {
        this.realms = realms;
    } //-- void setRealms( java.util.List )

    /**
     * Set the id of a security manager to be used by default
     * security system.
     * 
     * @param securityManager
     */
    public void setSecurityManager( String securityManager )
    {
        this.securityManager = securityManager;
    } //-- void setSecurityManager( String )

    /**
     * Set the version of the model.
     * 
     * @param version
     */
    public void setVersion( String version )
    {
        this.version = version;
    } //-- void setVersion( String )

    
    public static final String MODEL_VERSION = "2.0.3";

}
